<!doctype html>
<html lang="en">
<head>
    <title>Code coverage report for contracts/SellerUtils.sol</title>
    <meta charset="utf-8" />
    <link rel="stylesheet" href="../prettify.css" />
    <link rel="stylesheet" href="../base.css" />
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style type='text/css'>
        .coverage-summary .sorter {
            background-image: url(../sort-arrow-sprite.png);
        }
    </style>
</head>
<body>
<div class='wrapper'>
  <div class='pad1'>
    <h1>
      <a href="../index.html">all files</a> / <a href="index.html">contracts/</a> SellerUtils.sol
    </h1>
    <div class='clearfix'>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Statements</span>
        <span class='fraction'>13/13</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Branches</span>
        <span class='fraction'>14/14</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Functions</span>
        <span class='fraction'>5/5</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Lines</span>
        <span class='fraction'>15/15</span>
      </div>
    </div>
  </div>
  <div class='status-line high'></div>
<pre><table class="coverage">
<tr><td class="line-count quiet">1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149</td><td class="line-coverage quiet"><span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">15×</span>
<span class="cline-any cline-yes">13×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">12×</span>
<span class="cline-any cline-yes">9×</span>
<span class="cline-any cline-yes">110×</span>
<span class="cline-any cline-yes">110×</span>
<span class="cline-any cline-yes">110×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">50×</span>
<span class="cline-any cline-yes">50×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">122×</span>
<span class="cline-any cline-yes">121×</span>
<span class="cline-any cline-yes">120×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span></td><td class="text"><pre class="prettyprint lang-js">//SPDX-License-Identifier: MIT
pragma solidity ^0.8.0;
&nbsp;
import './Merkle.sol';
&nbsp;
/**
 * @title SellerUtils
 * @author gotbit
 * @notice Library for Seller contract utils and constants;
 **/
&nbsp;
library SellerUtils {
    using Merkle for bytes32[];
    // TYPES
&nbsp;
    struct NodeTier {
        uint256 pricePerNode;
        uint256 supply;
        uint256 capacityPerAddress;
    }
&nbsp;
    struct UserInfo {
        address user;
        uint256 nodesAmount;
    }
&nbsp;
    // CONSTANTS
&nbsp;
    uint256 public constant MIN_DURATION = 1 hours;
    uint256 public constant MAX_DURATION = 10 * 365 days; // 10 years
    uint256 public constant MAX_TIERS_COUNT = 100;
    uint256 public constant GAS_FOR_CALL = 5000;
&nbsp;
    // ERROR CONSTANTS
&nbsp;
    string public constant START_TOO_LOW = 'Start too low';
    string public constant TIMESTAMPS_CROSS = 'Timestamps cross';
    string public constant DURATION_TOO_LOW = 'Duration too low';
    string public constant DURATION_TOO_HIGH = 'Duration too high';
    string public constant ZERO_ROOT = 'Zero root';
    string public constant EMPTY_LINK = 'Empty link';
    string public constant CAP_ZERO = 'Cap Zero';
    string public constant ALLOC_TOO_LOW = 'Alloc too low';
    string public constant ZERO_PRICE = 'Zero price';
    string public constant CAP_REACHED = 'Zero price';
    string public constant ZERO_LENGTH = 'Zero length';
    string public constant LENGTH_TOO_HIGH = 'Length too high';
    string public constant ZERO_ADMIN = 'Zero admin';
    string public constant ZERO_COLLECTOR = 'Zero collector';
    string public constant NOT_COLLECTOR = 'Not collector';
    string public constant STARTED = 'Started';
    string public constant DUPLICATE = 'Duplicate';
    string public constant NOT_OVER = 'Not Over';
    string public constant ALREADY_COLLECTED = 'Already collected';
    string public constant NOTHING_TO_COLLECT = 'Nothing to collect';
    string public constant NODES_TOTAL_EXCEEDED = 'Nodes total exceeded';
    string public constant WRONG_INDEX = 'Wrong index';
    string public constant NOT_FULFILLED = 'Not fulfilled';
    string public constant WRONG_COST = 'Wrong cost';
    string public constant SEND_FAILED = 'Send failed';
    string public constant NOT_ALLOWED = 'Not allowed';
    string public constant ZERO_ADDRESS = 'Zero address';
    string public constant INVALID_SLICE = 'Invalid slice';
    string public constant ZERO_AMOUNT = 'Zero amount';
    string public constant WRONG_PROOF = 'Wrong proof';
    string public constant ZERO_NODES_BOUGHT = 'Zero nodes bought';
    string public constant NOT_IN_PROGRESS = 'Not in progress';
    string public constant MAX_PRICE_EXCEEDED = 'Max price exceeded';
    string public constant OVER = 'Over';
&nbsp;
    // EVENTS
&nbsp;
    event Init(
        address indexed token,
        uint256 indexed start,
        uint256 indexed end,
        NodeTier[] tiers,
        bytes32 root,
        string leaves,
        address collector
    );
&nbsp;
    event ResetStart(uint256 indexed start);
&nbsp;
    event ResetEnd(uint256 indexed end);
&nbsp;
    event ResetTiers(NodeTier[] indexed tiers);
&nbsp;
    event ResetRoot(bytes32 indexed root);
&nbsp;
    event ResetLeaves(string indexed link);
&nbsp;
    event ResetCollector(address indexed collector);
&nbsp;
    event ResetToken(address indexed token);
&nbsp;
    event Received(address indexed from, uint256 indexed amount);
&nbsp;
    event PurchasedNodes(
        address indexed user,
        uint256 indexed nodesAmount,
        uint256 indexed totalCost
    );
&nbsp;
    event ClaimedFunds(address indexed to, uint256 indexed amount);
&nbsp;
    event ClaimedExtraFunds(address indexed to, address indexed token, uint256 indexed amount);
&nbsp;
    // FUNCTIONS
&nbsp;
    function validateTiers(NodeTier[] memory _tiers) external pure {
        require(_tiers.length != 0, ZERO_LENGTH);
        require(_tiers.length &lt;= MAX_TIERS_COUNT, LENGTH_TOO_HIGH);
&nbsp;
        _validateTier(_tiers[0]);
        for (uint256 i = 1; i &lt; _tiers.length; ) {
            _validateTier(_tiers[i]);
            unchecked {
                ++i;
            }
        }
    }
&nbsp;
    function strCmp(string memory a, string memory b) external pure returns (bool) {
        return keccak256(bytes(a)) == keccak256(bytes(b));
    }
&nbsp;
    function sendETHViaCall(address payable to, uint256 value) external {
        (bool sent, bytes memory data) = to.call{value: value, gas: GAS_FOR_CALL}('');
        require(sent, SEND_FAILED);
    }
&nbsp;
    function hasAccess(
        address user,
        bytes32[] calldata proof,
        bytes32 root
    ) external view {
        // verify user address
        bytes32 leaf = keccak256(abi.encode(user));
        require(proof.verify(root, leaf), WRONG_PROOF);
    }
&nbsp;
    function _validateTier(NodeTier memory _tier) private pure {
        require(_tier.capacityPerAddress != 0, CAP_ZERO);
        require(_tier.supply &gt;= _tier.capacityPerAddress, ALLOC_TOO_LOW);
        require(_tier.pricePerNode != 0, ZERO_PRICE);
    }
}
&nbsp;</pre></td></tr>
</table></pre>
<div class='push'></div><!-- for sticky footer -->
</div><!-- /wrapper -->
<div class='footer quiet pad2 space-top1 center small'>
  Code coverage
  generated by <a href="http://istanbul-js.org/" target="_blank">istanbul</a> at Thu Jun 27 2024 19:04:27 GMT+0300 (Moscow Standard Time)
</div>
</div>
<script src="../prettify.js"></script>
<script>
window.onload = function () {
        if (typeof prettyPrint === 'function') {
            prettyPrint();
        }
};
</script>
<script src="../sorter.js"></script>
</body>
</html>
